var canvas, x, debut, fin, pas, valeur_initiale, no, nom, r, n, h, c, gliss;

/**
 * Fonction exécutée une fois, au départ
 */
function actions_initiales() {
  definirPageWebExecution('http://profmath.uqam.ca/~boileau/p5VisuelWEB/MODELES/PolygonesReguliers/execution.html');
  canvas=creerCanvas(620,620);
  initialiser();
}

/**
 * Fonction exécutée périodiquement, de façon répétée
 */
function actions_en_boucle() {
  tracer_la_figure(valeur_de_la_glissiere(2), valeur_de_la_glissiere(1));
}

/**
 * Décrire cette fonction…
 */
function initialiser() {
  canvas.parent((select('#'+'p5Vcanvas')));
  (select('#'+'titrePage')).html('Polygones réguliers');
  (select('#'+'auteur')).html('André Boileau');
  (select('#'+'para1')).html('Nous allons tracer des polygones comme ceux montrés ci-dessous.');
  (select('#'+'para2')).html('');
  (select('#'+'para3')).html('');
  (select('#'+'para4')).hide();
  (select('#'+'para5')).hide();
  (select('#'+'gliss3')).hide();
  (select('#'+'gliss4')).hide();
  (select('#'+'gliss5')).hide();
  (select('#'+'bouton1')).hide();
  (select('#'+'bouton2')).hide();
  (select('#'+'bouton3')).hide();
  parametrer_glissiere(1, 'Rayon', 0, 300, 0.01, 300);
  parametrer_glissiere(2, 'Nombre de côtés', 3, 30, 1, 3);
  stroke((color(255,0,0,255)));
  fill((color(255,255,0,255)));
}

/**
 * Décrire cette fonction…
 */
function tracer_la_figure(n, r) {
  background((color(230,230,230,255)));h = r * Math.cos((180 / n) / 180 * Math.PI);
  c = 2 * r * Math.sin((180 / n) / 180 * Math.PI);
  leveCrayon();
  recule(h);
  droite(90);
  recule((c / 2));
  baisseCrayon();
  debutPoly();
  for (var count = 0; count < n; count++) {
    avance(c);
    gauche((360 / n));
  }
  finPoly();
  leveCrayon();
  avance((c / 2));
  gauche(90);
  avance(h);
  baisseCrayon();
}

/**
 * Décrire cette fonction…
 */
function valeur_de_la_glissiere(no) {
  (select('#'+(['gliss',no,'_val'].join('')))).html((traiterNombre((select('#'+(['gliss',no,'_gliss'].join('')))).value())));
  return traiterNombre((select('#'+(['gliss',no,'_gliss'].join('')))).value());
}

/**
 * Décrire cette fonction…
 */
function parametrer_glissiere(no, nom, debut, fin, pas, valeur_initiale) {
  (select('#'+(['gliss',no,'_nom'].join('')))).html(nom);
  gliss = select('#'+(['gliss',no,'_gliss'].join('')));
  gliss.elt.min =debut;
  gliss.elt.max =fin;
  gliss.elt.step =pas;
  gliss.elt.defaultValue =valeur_initiale;
}
