var canvas, x, debut, fin, pas, valeur_initiale, no, nom, r, n, h, c, gliss;

/**
 * Fonction exécutée une fois, au départ
 */
function actions_initiales() {
  definirPageWebExecution('');
  canevas=creerCanvas(620,620); canvas=canevas;
  initialiser();
}

/**
 * Décrire cette fonction…
 */
function parametrer_glissiere(no, nom, debut, fin, pas, valeur_initiale) {
  fixeContenuPrudent("(select('#'+(['gliss',no,'_nom'].join(''))))",(select('#'+(['gliss',no,'_nom'].join('')))),nom);
  gliss = select('#'+(['gliss',no,'_gliss'].join('')));
  eval('gliss.elt.min =debut');
  eval('gliss.elt.max =fin');
  eval('gliss.elt.step =pas');
  eval('gliss.elt.defaultValue =valeur_initiale');
}

/**
 * Décrire cette fonction…
 */
function calculer_hauteur(r, n) {
  return r * Math.cos((180 / n) / 180 * Math.PI);
}

/**
 * Décrire cette fonction…
 */
function initialiser() {
  assignerParentPrudent("canvas",canvas,"(select('#'+'p5Vcanvas'))",(select('#'+'p5Vcanvas')));
  fixeContenuPrudent("(select('#'+'titrePage'))",(select('#'+'titrePage')),'Polygones réguliers');
  fixeContenuPrudent("(select('#'+'auteur'))",(select('#'+'auteur')),'André Boileau');
  fixeContenuPrudent("(select('#'+'para1'))",(select('#'+'para1')),'Nous allons tracer des polygones comme ceux montrés ci-dessous.');
  fixeContenuPrudent("(select('#'+'para2'))",(select('#'+'para2')),'');
  fixeContenuPrudent("(select('#'+'para3'))",(select('#'+'para3')),'');
  cacherObjetPrudent("(select('#'+'para4'))",(select('#'+'para4')));
  cacherObjetPrudent("(select('#'+'para5'))",(select('#'+'para5')));
  cacherObjetPrudent("(select('#'+'gliss3'))",(select('#'+'gliss3')));
  cacherObjetPrudent("(select('#'+'gliss4'))",(select('#'+'gliss4')));
  cacherObjetPrudent("(select('#'+'gliss5'))",(select('#'+'gliss5')));
  cacherObjetPrudent("(select('#'+'bouton1'))",(select('#'+'bouton1')));
  cacherObjetPrudent("(select('#'+'bouton2'))",(select('#'+'bouton2')));
  cacherObjetPrudent("(select('#'+'bouton3'))",(select('#'+'bouton3')));
  parametrer_glissiere(1, 'Rayon', 0, 300, 0.01, 300);
  parametrer_glissiere(2, 'Nombre de côtés', 3, 30, 1, 3);
  stroke_((color(255,0,0,255)));
  fill_((color(255,255,0,255)));
}

/**
 * Décrire cette fonction…
 */
function valeur_de_la_glissiere(no) {
  fixeContenuPrudent("(select('#'+(['gliss',no,'_val'].join(''))))",(select('#'+(['gliss',no,'_val'].join('')))),(valeurPrudent("(select('#'+(['gliss',no,'_gliss'].join(''))))",(select('#'+(['gliss',no,'_gliss'].join('')))))));
  return valeurPrudent("(select('#'+(['gliss',no,'_gliss'].join(''))))",(select('#'+(['gliss',no,'_gliss'].join('')))));
}

/**
 * Décrire cette fonction…
 */
function calculer_c_C3_B4t_C3_A9(r, n) {
  return 2 * r * Math.sin((180 / n) / 180 * Math.PI);
}

/**
 * Fonction exécutée périodiquement, de façon répétée
 */
function actions_en_boucle() {
  tracer_la_figure(valeur_de_la_glissiere(2), valeur_de_la_glissiere(1));
}

/**
 * Décrire cette fonction…
 */
function tracer_la_figure(n, r) {
  couleurFondC((color(230,230,230,255)));
  h = calculer_hauteur(r, n);
  c = calculer_c_C3_B4t_C3_A9(r, n);
  leveCrayon();
  recule(h);
  droite(90);
  recule((c / 2));
  baisseCrayon();
  debutPoly();
  for (var count = 0; count < n; count++) {
    avance(c);
    gauche((360 / n));
  }
  finPoly();
  leveCrayon();
  avance((c / 2));
  gauche(90);
  avance(h);
  baisseCrayon();
}
